<template>
  <div class="content">
    <!-- <PageTitle>Buildings</PageTitle> -->
    <div class="mapBox">
      <div id="map" ref="map" class="map"></div>
      <div ref="popup" class="ol-popup">
        <a href="#" ref="popup-closer" class="ol-popup-closer"></a>
        <div ref="popup-content"></div>
      </div>
    </div>
  </div>
</template>

<script>
// import PageTitle from "./atoms/PageTitle.vue";
// import axios from "axios";
// import store from "@/store/auth";

import "ol/ol.css";
import { Map, View } from "ol";
import { Tile as TileLayer, Vector as VectorLayer } from "ol/layer";
import { OSM, Vector as VectorSource } from "ol/source";
import { fromLonLat } from "ol/proj";
import Cluster from "ol/source/Cluster";
import Feature from "ol/Feature";
import Point from "ol/geom/Point";
// import { Style, Circle as CircleStyle, Stroke, Fill } from "ol/style";
import Overlay from "ol/Overlay";

export default {
  mounted() {
    this.initMap();
  },
  methods: {
    initMap() {
      const map = new Map({
        target: this.$refs.map,
        layers: [
          new TileLayer({
            source: new OSM(),
          }),
        ],
        view: new View({
          center: fromLonLat([-95.7129, 37.0902]),
          zoom: 4,
        }),
      });

      const locations = [
        {
          name: "Location 1",
          lon: -95.7129,
          lat: 37.0902,
          info: "Info for location 1",
        },
        {
          name: "Location 2",
          lon: -120.7401,
          lat: 46.6021,
          info: "Info for location 2",
        },
        {
          name: "Location 3",
          lon: -100.7837,
          lat: 48.8566,
          info: "Info for location 3",
        },
      ];

      const features = locations.map((location) => {
        const geometry = new Point(fromLonLat([location.lon, location.lat]));
        const feature = new Feature(geometry);
        feature.setProperties({
          name: location.name,
          info: location.info,
        });
        return feature;
      });

      const clusterSource = new Cluster({
        distance: 40,
        source: new VectorSource({
          features,
        }),
      });

      // const styleCache = {};
      const clusters = new VectorLayer({
        source: clusterSource,
        // style: function (feature) {
        //   const size = feature.get("features").length;
        //   let style = styleCache[size];
        //   if (!style) {
        //     style = new Style({
        //       image: new CircleStyle({
        //         radius: 10,
        //         stroke: new Stroke({
        //           color: "#fff",
        //         }),
        //         fill: new Fill({
        //           color: "#3399CC",
        //         }),
        //       }),
        //       text: new Text({
        //         text: size.toString(),
        //         fill: new Fill({
        //           color: "#fff",
        //         }),
        //       }),
        //     });
        //     styleCache[size] = style;
        //   }
        //   return;
        // },
      });

      map.addLayer(clusters);

      const popup = new Overlay({
        element: this.$refs.popup,
        autoPan: true,
        autoPanAnimation: {
          duration: 250,
        },
      });
      map.addOverlay(popup);

      const closer = this.$refs["popup-closer"];
      closer.onclick = function () {
        popup.setPosition(undefined);
        closer.blur();
        return false;
      };

      map.on(
        "click",
        function (evt) {
          const feature = map.forEachFeatureAtPixel(
            evt.pixel,
            function (feature) {
              return feature;
            }
          );
          if (feature) {
            const geometry = feature.getGeometry();
            const coord = geometry.getCoordinates();
            const name = feature.get("name");
            const info = feature.get("info");
            const content = `
        <h4>${name}</h4>
        <p>${info}</p>
      `;
            this.$refs["popup-content"].innerHTML = content;
            popup.setPosition(coord);
          } else {
            popup.setPosition(undefined);
            closer.blur();
          }
        }.bind(this)
      );
    },
  },
};
</script>

<style lang="scss" scoped>
.mapBox {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  width: 100%;
  height: 88vh;
  #map {
    flex-grow: 5;
    height: auto;
    min-width: 75%;
    min-height: 75%;
  }
  #mapSidePanel {
    flex-grow: 1;
  }
}
</style>
